# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class Snapshot(pulumi.CustomResource):
    """
    Manages a Disk Snapshot.
    """
    def __init__(__self__, __name__, __opts__=None, create_option=None, disk_size_gb=None, encryption_settings=None, location=None, name=None, resource_group_name=None, source_resource_id=None, source_uri=None, storage_account_id=None, tags=None):
        """Create a Snapshot resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not create_option:
            raise TypeError('Missing required property create_option')
        elif not isinstance(create_option, basestring):
            raise TypeError('Expected property create_option to be a basestring')
        __self__.create_option = create_option
        """
        Indicates how the snapshot is to be created. Possible values are `Copy` or `Import`. Changing this forces a new resource to be created.
        """
        __props__['createOption'] = create_option

        if disk_size_gb and not isinstance(disk_size_gb, int):
            raise TypeError('Expected property disk_size_gb to be a int')
        __self__.disk_size_gb = disk_size_gb
        """
        The size of the Snapshotted Disk in GB.
        """
        __props__['diskSizeGb'] = disk_size_gb

        if encryption_settings and not isinstance(encryption_settings, dict):
            raise TypeError('Expected property encryption_settings to be a dict')
        __self__.encryption_settings = encryption_settings
        __props__['encryptionSettings'] = encryption_settings

        if not location:
            raise TypeError('Missing required property location')
        elif not isinstance(location, basestring):
            raise TypeError('Expected property location to be a basestring')
        __self__.location = location
        """
        Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.
        """
        __props__['location'] = location

        if name and not isinstance(name, basestring):
            raise TypeError('Expected property name to be a basestring')
        __self__.name = name
        """
        Specifies the name of the Snapshot resource. Changing this forces a new resource to be created.
        """
        __props__['name'] = name

        if not resource_group_name:
            raise TypeError('Missing required property resource_group_name')
        elif not isinstance(resource_group_name, basestring):
            raise TypeError('Expected property resource_group_name to be a basestring')
        __self__.resource_group_name = resource_group_name
        """
        The name of the resource group in which to create the Snapshot. Changing this forces a new resource to be created.
        """
        __props__['resourceGroupName'] = resource_group_name

        if source_resource_id and not isinstance(source_resource_id, basestring):
            raise TypeError('Expected property source_resource_id to be a basestring')
        __self__.source_resource_id = source_resource_id
        """
        Specifies a reference to an existing snapshot, when `create_option` is `Copy`. Changing this forces a new resource to be created.
        """
        __props__['sourceResourceId'] = source_resource_id

        if source_uri and not isinstance(source_uri, basestring):
            raise TypeError('Expected property source_uri to be a basestring')
        __self__.source_uri = source_uri
        """
        Specifies the URI to a Managed or Unmanaged Disk. Changing this forces a new resource to be created.
        """
        __props__['sourceUri'] = source_uri

        if storage_account_id and not isinstance(storage_account_id, basestring):
            raise TypeError('Expected property storage_account_id to be a basestring')
        __self__.storage_account_id = storage_account_id
        """
        Specifies the ID of an storage account. Used with `source_uri` to allow authorization during import of unmanaged blobs from a different subscription. Changing this forces a new resource to be created.
        """
        __props__['storageAccountId'] = storage_account_id

        if tags and not isinstance(tags, dict):
            raise TypeError('Expected property tags to be a dict')
        __self__.tags = tags
        __props__['tags'] = tags

        super(Snapshot, __self__).__init__(
            'azure:compute/snapshot:Snapshot',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'createOption' in outs:
            self.create_option = outs['createOption']
        if 'diskSizeGb' in outs:
            self.disk_size_gb = outs['diskSizeGb']
        if 'encryptionSettings' in outs:
            self.encryption_settings = outs['encryptionSettings']
        if 'location' in outs:
            self.location = outs['location']
        if 'name' in outs:
            self.name = outs['name']
        if 'resourceGroupName' in outs:
            self.resource_group_name = outs['resourceGroupName']
        if 'sourceResourceId' in outs:
            self.source_resource_id = outs['sourceResourceId']
        if 'sourceUri' in outs:
            self.source_uri = outs['sourceUri']
        if 'storageAccountId' in outs:
            self.storage_account_id = outs['storageAccountId']
        if 'tags' in outs:
            self.tags = outs['tags']
