# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class Zone(pulumi.CustomResource):
    """
    Enables you to manage DNS zones within Azure DNS. These zones are hosted on Azure's name servers to which you can delegate the zone from the parent domain.
    """
    def __init__(__self__, __name__, __opts__=None, name=None, resource_group_name=None, tags=None):
        """Create a Zone resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if name and not isinstance(name, basestring):
            raise TypeError('Expected property name to be a basestring')
        __self__.name = name
        """
        The name of the DNS Zone. Must be a valid domain name.
        """
        __props__['name'] = name

        if not resource_group_name:
            raise TypeError('Missing required property resource_group_name')
        elif not isinstance(resource_group_name, basestring):
            raise TypeError('Expected property resource_group_name to be a basestring')
        __self__.resource_group_name = resource_group_name
        """
        Specifies the resource group where the resource exists. Changing this forces a new resource to be created.
        """
        __props__['resourceGroupName'] = resource_group_name

        if tags and not isinstance(tags, dict):
            raise TypeError('Expected property tags to be a dict')
        __self__.tags = tags
        """
        A mapping of tags to assign to the resource.
        """
        __props__['tags'] = tags

        __self__.max_number_of_record_sets = pulumi.runtime.UNKNOWN
        """
        (Optional) Maximum number of Records in the zone. Defaults to `1000`.
        """
        __self__.name_servers = pulumi.runtime.UNKNOWN
        """
        (Optional) A list of values that make up the NS record for the zone.
        """
        __self__.number_of_record_sets = pulumi.runtime.UNKNOWN
        """
        (Optional) The number of records already in the zone.
        """

        super(Zone, __self__).__init__(
            'azure:dns/zone:Zone',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'maxNumberOfRecordSets' in outs:
            self.max_number_of_record_sets = outs['maxNumberOfRecordSets']
        if 'name' in outs:
            self.name = outs['name']
        if 'nameServers' in outs:
            self.name_servers = outs['nameServers']
        if 'numberOfRecordSets' in outs:
            self.number_of_record_sets = outs['numberOfRecordSets']
        if 'resourceGroupName' in outs:
            self.resource_group_name = outs['resourceGroupName']
        if 'tags' in outs:
            self.tags = outs['tags']
